# Copyright (c) 2024 Project CHIP Authors
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

name: 42.4.1. [TC-TSTAT-4.1] Preset attributes with server as DUT

PICS:
    - TSTAT.S

config:
    nodeId: 0x12344321
    cluster: "Thermostat"
    endpoint: 1

tests:
    - label: "Step 1: Commission DUT to TH"
      cluster: "DelayCommands"
      command: "WaitForCommissionee"
      arguments:
          values:
              - name: "nodeId"
                value: nodeId

    - label: "Saving value for comparision in step 2 read PresetTypes attribute"
      PICS: TSTAT.S.A0048
      command: "readAttribute"
      attribute: "PresetTypes"
      response:
          saveAs: PresetTypesValue

    - label:
          "Saving value for comparision in step 3 read NumberOfPresets attribute"
      PICS: TSTAT.S.A004a
      command: "readAttribute"
      attribute: "NumberOfPresets"
      response:
          saveAs: NumberOfPresetsValue

    - label:
          "Saving value for comparision in step 4 read ActivePresetHandleValue
          attribute"
      PICS: TSTAT.S.A004e
      command: "readAttribute"
      attribute: "ActivePresetHandle"
      response:
          saveAs: ActivePresetHandleValue

    - label: "Saving value for comparision in step 5 read Presets attribute"
      PICS: TSTAT.S.A0050
      command: "readAttribute"
      attribute: "Presets"
      response:
          saveAs: PresetsValue

    - label: "Saving value for comparision in step 6 read Schedules attribute"
      PICS: TSTAT.S.A0051
      command: "readAttribute"
      attribute: "Schedules"
      response:
          saveAs: SchedulesValue

    - label: "Step 2: TH reads the PresetTypes attribute from the DUT"
      PICS: TSTAT.S.F08 && TSTAT.S.A0048
      command: "readAttribute"
      attribute: "PresetTypes"
      response:
          constraints:
              type: list

    - label: "Step 3: TH reads the NumberOfPresets attribute from the DUT"
      PICS: TSTAT.S.F08 && TSTAT.S.A004a
      command: "readAttribute"
      attribute: "NumberOfPresets"
      response:
          constraints:
              type: int8u

    - label: "Step 4: TH reads the ActivePresetHandle attribute from the DUT"
      PICS: TSTAT.S.F08 && TSTAT.S.A004e
      command: "readAttribute"
      attribute: "ActivePresetHandle"
      response:
          constraints:
              type: octstr

    - label: "Step 5: TH reads the Presets attribute from the DUT"
      PICS: TSTAT.S.F08 && TSTAT.S.A0050
      command: "readAttribute"
      attribute: "Presets"
      response:
          constraints:
              type: list

    - label: "Step 6: TH reads the Schedules attribute from the DUT"
      PICS: TSTAT.S.F07 && TSTAT.S.A0051
      command: "readAttribute"
      attribute: "Schedules"
      response:
          constraints:
              type: list
